<template>
  <q-layout>
    <q-page-container>
      <q-page class="bg-grey-3 q-pb-lg">
        <header-component />
        <router-view :key="$route.fullPath" />
      </q-page>
    </q-page-container>
    <footer-component />
  </q-layout>
</template>

<script>
import { mapActions, mapState } from 'vuex';
import HeaderComponent from '~/components/Header.vue';
import FooterComponent from '~/components/Footer.vue';

export default {
  components: { HeaderComponent, FooterComponent },
  computed: {
    ...mapState({
      user: state => state.auth.user
    })
  },
  async mounted() {
    await this.getAuthUser();
    this.getSettings();
    this.subscribeNotifications();
    this.getUserNotifications(this.user.id);
  },
  beforeDestroy() {
    this.unsubscribeNotifications();
  },
  methods: {
    ...mapActions({
      getAuthUser: 'auth/getAuthUser',
      getUserNotifications: 'notifications/getUserNotifications',
      subscribeNotifications: 'notifications/subscribeNotifications',
      unsubscribeNotifications: 'notifications/unsubscribeNotifications',
      getSettings: 'settings/getSettings'
    })
  }
};
</script>
